/**
 * Copyright (c) 2011 Chase
 * 
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 * 
 *    1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software
 *    in a product, an acknowledgment in the product documentation would be
 *    appreciated but is not required.
 * 
 *    2. Altered source versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.
 * 
 *    3. This notice may not be removed or altered from any source
 *    distribution.
 */

package cs;

import cs.move.Kakeru;
import addon.RaikoGun;
import robocode.BulletHitBulletEvent;
import robocode.BulletHitEvent;
import robocode.ScannedRobotEvent;
import robocode.util.Utils;

/**
 * Weapon
 * <br/><br/>
 * In Classical Japanese, Daikama means "Scythe", Dai (large), Kama (sickle)
 * 
 * @author Chase
 */
public abstract class Daikama extends Kakeru {
	public static boolean isMC2k7 = true;
	private RaikoGun raiko = new RaikoGun(this);

	/**
	 * At the moment, just point the gun at the enemy
	 */
	@Override
	public void onScannedRobot(ScannedRobotEvent e) {
		super.onScannedRobot(e);

		/**
		 * Our radar is a tad bit more important then the gun,
		 * so let it do what it needs to do
		 */
		if(initialTick != 0)
			return;

		if(isMC2k7) {
			raiko.onScannedRobot(e);
			return;
		}

		double angleToEnemy = e.getBearingRadians() + status.getHeadingRadians();
		double toTurn = Utils.normalRelativeAngle(angleToEnemy - status.getGunHeadingRadians());
		peer.setTurnGun(toTurn);
	}

	@Override
	public void onBulletHit(BulletHitEvent e) {
		super.onBulletHit(e);
	}

	@Override
	public void onBulletHitBullet(BulletHitBulletEvent e) {
		super.onBulletHitBullet(e);
	}
}
