package cs.move;

import cs.utils.Tools;

public class Data {
	long globalTime;

	public double distance;
	double lateralVelocity;
	double advancingVelcity;
	double bulletFlightTime;
	double wallForward;
	double wallReverse;
	double distLast10;
	long timeSinceDirectionChange;

	double guessfactor;

	double weight = 1.0;

	public double[] getDataArray() {
		return new double[] {
				Math.abs(lateralVelocity)/8.0,
				(advancingVelcity+8.0)/16.0,
				distLast10/(8*10),
				Tools.limit(0,Tools.abs(wallForward)/Math.PI*0.5,1),
				Tools.limit(0,Tools.abs(wallReverse)/Math.PI,1),
				Tools.min(distance/800,1),
				Tools.min(timeSinceDirectionChange/400.0,1)
				//1.0/(1.0+timeSinceDirectionChange/bulletFlightTime),
		};
	}

	public double[] getDataWeights() {
		return new double[] {
				6,
				1,
				3.2,
				4,
				2,
				1,
				2.2,
		};
	}

	public double[] getWeightedDataArray() {
		double[] data = getDataArray();
		double[] weights = getDataWeights();
		for(int i=0;i<data.length;++i) {
			data[i] *= weights[i];
		}
		return data;
	}
}
